  /**
  * Load WebQuestions templates.
   */
  private Map<Integer, Template> loadTemplates(String path) {
    Map<Integer, Template> templates = new HashMap<Integer, Template>();
    try {
      DatumReader<Template> datumReader = new SpecificDatumReader<Template>(Template.class);
      DataFileReader<Template> dataFileReader = new DataFileReader<Template>(new File(path), datumReader);
      while (dataFileReader.hasNext()) {
        // add labeled utterance
        Template template = dataFileReader.next();
        templates.put(template.getId(), template);
      }
      dataFileReader.close();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    return templates;
  }